unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, CPort, CPortCtl, Buttons;

type
  TForm1 = class(TForm)
    ComPort: TComPort;
    Panel1: TPanel;
    Panel2: TPanel;
    bSetupCOM: TButton;
    Button_Open: TButton;
    Panel4: TPanel;
    ComLed5: TComLed;
    ComLed6: TComLed;
    Label2: TLabel;
    Label6: TLabel;
    Panel5: TPanel;
    GroupBox1: TGroupBox;
    rgPORTA: TRadioGroup;
    rgPORTB: TRadioGroup;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    eDataPORTA: TEdit;
    sbSendPORTA: TSpeedButton;
    sbSendPORTB: TSpeedButton;
    eDataPORTB: TEdit;
    sbGetPORTA: TSpeedButton;
    sbGetPORTB: TSpeedButton;
    procedure bSetupCOMClick(Sender: TObject);
    procedure Button_OpenClick(Sender: TObject);
    procedure ComPortOpen(Sender: TObject);
    procedure ComPortClose(Sender: TObject);
    procedure ComPortRxChar(Sender: TObject; Count: Integer);
    procedure rgPORTAClick(Sender: TObject);
    procedure sbSendPORTAClick(Sender: TObject);
    procedure sbGetPORTAClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure rgPORTBClick(Sender: TObject);
    procedure sbSendPORTBClick(Sender: TObject);
    procedure sbGetPORTBClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  status: integer;// 

implementation

{$R *.dfm}

procedure TForm1.bSetupCOMClick(Sender: TObject);
begin
 ComPort.ShowSetupDialog;
end;

procedure TForm1.Button_OpenClick(Sender: TObject);
begin
  if ComPort.Connected then
    ComPort.Close
  else
    ComPort.Open;
end;

procedure TForm1.ComPortOpen(Sender: TObject);
begin
  Button_Open.Caption := ' ';
end;

procedure TForm1.ComPortClose(Sender: TObject);
begin
  if Button_Open <> nil then
    Button_Open.Caption := ' ';
end;

procedure TForm1.ComPortRxChar(Sender: TObject; Count: Integer);
var
  q:integer;
begin
// 

  q:= 0;
  ComPort.Read(q,1);
 if (status = 1) then
 begin
  eDataPORTA.Text:= IntToStr (q);
  status:= 0;
 end
  else if (status = 2) then
  begin
   eDataPORTB.Text:= IntToStr (q);
   status:= 0;
  end;

end;

procedure TForm1.rgPORTAClick(Sender: TObject);
var
  I:integer;
begin
if ComPort.Connected then
 begin
//  
 if rgPORTA.ItemIndex = 0 then
 begin
 //PORTA -  
 //  
  sbGetPORTA.Enabled := false;
 //  
  sbSendPORTA.Enabled := true;
 // 10 - PORTA  
  i:= 10;
  ComPort.Write(i,1);
 end
 else
 begin
 //PORTA -  
  //  
  sbGetPORTA.Enabled := true;
 //  
  sbSendPORTA.Enabled := false;
 // 11 - PORTA  
   i:= 11;
  ComPort.Write(i,1);
 end;
 end 
  else ShowMessage ('   ');

end;

procedure TForm1.sbSendPORTAClick(Sender: TObject);
var
   Str: string;
   q: integer;
   i: array [0..1] of  integer;
begin
if eDataPORTA.Text = '' then
 begin
  ShowMessage (' ,  ');
  exit;
 end;
 
if ComPort.Connected then
 begin
// 
  i[0]:= 0;//   
  //   
  Str:= eDataPORTA.Text;
  i[1]:=StrToInt(str);
  q:= 0;
  ComPort.Write(q,1);
  q:= StrToInt(str);
  ComPort.Write(q,1);
 end
  else ShowMessage ('   ');

end;

procedure TForm1.sbGetPORTAClick(Sender: TObject);
var
  i: integer;
begin
if ComPort.Connected then
 begin
// 
  i:= 1;
  ComPort.Write(i,1);//   PORTA
  status:= 1;
 end
  else ShowMessage ('   ');
end;

procedure TForm1.FormCreate(Sender: TObject);
var i: integer;
begin
//  PORTA  PORTB    
 status:= 0;
end;

procedure TForm1.rgPORTBClick(Sender: TObject);
var
  I:integer;
begin
if ComPort.Connected then
 begin
//  
 if rgPORTB.ItemIndex = 0 then
 begin
 //PORTA -  
 //  
  sbGetPORTB.Enabled := false;
 //  
  sbSendPORTB.Enabled := true;
 // 20 - PORTB  
  i:= 20;
  ComPort.Write(i,1);
 end
 else
 begin
 //PORTA -  
  //  
  sbGetPORTB.Enabled := true;
 //  
  sbSendPORTB.Enabled := false;
 // 21 - PORTB  
  i:= 21;
  ComPort.Write(i,1);
 end;
 end
  else ShowMessage ('   ');

end;

procedure TForm1.sbSendPORTBClick(Sender: TObject);
var
   Str: string;
   q: integer;
   i: array [0..1] of  integer;
begin
if eDataPORTB.Text = '' then
 begin
  ShowMessage (' ,  ');
  exit;
 end;

if ComPort.Connected then
 begin
// 
  i[0]:= 2;//   B
  //   
  Str:= eDataPORTB.Text;
  i[1]:=StrToInt(str);
  q:= 2;
  ComPort.Write(q,1);
  q:= StrToInt(str);
  ComPort.Write(q,1);
 end
  else ShowMessage ('   ');
end;

procedure TForm1.sbGetPORTBClick(Sender: TObject);
var i: integer;
begin
if ComPort.Connected then
 begin
//   
  i:= 3;
  ComPort.Write(i,1);
  status:= 2;
 end
  else ShowMessage ('   ');
end;

end.
