

//      FLASH
//  8051F0007,   7.3728 

//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------

#include <c8051f000.h>                 // SFR declarations
#include <stdio.h>

//    
//								        04h     05h     06h     07h
static unsigned int xdata reg_temp[]={0x0000, 0x0000, 0x0000, 0x0000};

//  . (0 -  , 1 - ).
unsigned char write_coeff(unsigned char *urt_rx, unsigned int *reg_mb)
{
unsigned char f_1,f_2;
unsigned int f_3;
unsigned char code *read_coeff;
unsigned char xdata *idata pwrite;
   
// ,      . 

read_coeff=(unsigned char code*)0x6000; // 


for (f_1=0; f_1 < 4; f_1++)
	{
f_3=((unsigned int)(*read_coeff))<<8;
read_coeff++;
f_3+=(*read_coeff);
read_coeff++;
reg_temp[f_1]=f_3;
	}
f_2=0;
for (f_1=urt_rx[3]; f_1 < (urt_rx[3]+urt_rx[5]); f_1++) //   MODBUS   
									//  
	{ 
	reg_mb[f_1]=(((unsigned int)urt_rx[7+f_2])<<8)+urt_rx[8+f_2];
	reg_temp[f_1-4]=reg_mb[f_1];
	f_2+=2;
									 
	}
EA=0; // 
pwrite=(unsigned char xdata*)0x6000; //  
FLSCL=0x88; //   
PSCTL=0x03; //  
*pwrite=0;
PSCTL=0x00;//  

pwrite=(unsigned char xdata*)0x6000; //  
PSCTL=0x01; //  
f_2=0;
for (f_1=0; f_1 < 4; f_1++)
	{
*pwrite=(reg_temp[f_1]>>8);
pwrite++;
*pwrite=reg_temp[f_1];
pwrite++;
	}
PSCTL=0x00; //  
FLSCL=0x8F;
EA=1; // 

read_coeff=(unsigned char code*)0x6000; //    

f_2=0;
for (f_1=0; f_1 < 4; f_1++)
	{
f_3=((unsigned int)(*read_coeff))<<8;
read_coeff++;
f_3+=(*read_coeff);
read_coeff++;
if (f_3!=reg_temp[f_1]) f_2=0xff;
	}

if (f_2==0) return 0;
	else return 1;
}

