;=== 2,  TW.inc===
.equ	START		=$8		; 201
.equ	RPT_START	=$10
.equ	MT_SLA_ACK	=$18
.equ	MT_DATA_ACK	=$28
.equ	MR_SLA_ACK	=$40
.equ	MR_SLA_NOACK	=$48
.equ	MR_DATA_ACK	=$50
.equ	MR_DATA_NACK	=$58
.equ	aWr2C	=$78	; PCF8548  
.equ	aRd2C	=aWr2C+1	;  

;==============
;  :
WaitTransmit:
	in	tmp,TWCR 		; 202
	sbrs	tmp,TWINT 	
	rjmp	WaitTransmit
	in	tmp,TWSR 		; 203
	andi	tmp,$ff-7
	cp	tmp,TWStat 		; 204
	breq	mOK		
	rcall	ERROR
mOK:	ret	  
;==============
ERROR:	ret
;=====================
;  START:
TWStart:
ldi	tmp,(1<<TWINT)|(1<<TWSTA) | (1<<TWEN)
	out	TWCR, tmp 		; 205
	ldi	TWStat,START	
	rcall	WaitTransmit
	ret	
;==================
;   STOP
TWStop:	
ldi 	tmp,(1<<TWINT) | (1<<TWSTO) | (1<<TWEN)
	out 	TWCR,tmp 		; 206
	ret	
;===================
;  (   TWIdata)	
TWDataTrns:
	out	TWDR,TWData
	ldi	tmp,(1<<TWINT) | (1<<TWEN)
	out	TWCR,tmp 		; 207
rcall	WaitTransmit
	ret
;=========
.equ	Func	=5			; 208
.equ	MX	=4
.equ	MY	=3
.equ	PD	=2
.equ	V	=1
.equ	H	=0
.equ	FuncSet	=(1<<Func)|(1<<MX)|(1<<MY)|(0<<PD)|(0<<V)|(0<<H)

;,    H=0:
.equ	PRS	=0			; 209
.equ	VlcdRng	=$04|(1<<PRS)

; :
.equ	D	=2	
.equ	E	=0
.equ	ScrMode	=$08|(1<<D)|(0<<E)
 
.equ	S1	=1
.equ	S0	=0
.equ	UMult	=$10|(1<<S1)|(0<<S0)

.equ	setY	=$40
.equ	setX	=$80

; ,    H=1:
.equ	TC1	=1			; 210
.equ	TC0	=0
.equ	KTermo	=$04|(0<<TC1)|(0<<TC0)

.equ	DO	=2
.equ	TRS	=1
.equ	BRS	=0
.equ	ScrRevers=$08|(1<<DO)|(0<<TRS)|(1<<BRS)
	
.equ	BS2	=2
.equ	BS1	=1
.equ	BS0	=0
.equ	Bias	=$10|(0<<BS2)|(1<<BS1)|(0<<BS0)

.equ	Vop6	=6
.equ	Vlcd	=$80|(1<<Vop6)
;======================================
; :
DisplayIni:
	rcall	TWWrAddr		; 211

	ldi	datrs,$00 		; 212
	rcall	WrBt2C
	ldi	datrs,FuncSet|(1<<H)	;H=1 
	rcall	WrBt2C
;========
;   H=1:
	ldi	datrs,Bias		; 213
	rcall	WrBt2C
	ldi	datrs,ScrRevers	
	rcall	WrBt2C
	ldi	datrs,Vlcd
	rcall	WrBt2C
; H=0:
	ldi	datrs,FuncSet|(0<<H) 	; 214
	rcall	WrBt2C
;   H=0:========
	ldi	datrs,VlcdRng		; 215
	rcall	WrBt2C
	ldi	datrs,UMult	;U x 3
	rcall	WrBt2C
	ldi	datrs,ScrMode	;D:E=10
	rcall	WrBt2C
	ret
;=^= 2=^=

