#include<mega8515.h>
#include<delay.h>

// RS=0 - , RS=1 - 
// RW=0 -    
// E -        1  0

unsigned char data[]={'H', 'E', 'L', 'L', 'O'};

unsigned char i;	//  

void pulse_e(void)
{
delay_us(1);
PORTC.2=1;	// E 
delay_us(1);
PORTC.2=0;	// E 
} // pulse_e

void send_char(unsigned char c)
{
//    
PORTC=(c&0b11110000)|(0b00000001); 
pulse_e();

//    
PORTC=((c<<4)&0b11110000)|(0b00000001); 
pulse_e();
delay_us(45); //   40 
}

void send_cmd(unsigned char c)
{
//    
PORTC=(c&0b11110000); 
pulse_e();

//    
PORTC=((c<<4)&0b11110000); 
pulse_e();     
delay_us(45); //   40 
}

void main(void)
{
//    C    
DDRC=0xff;	
PORTC=0b00000000;

//  15    
delay_ms(15);		
                                                            
//    : RS=0, RW=0, E=0

//   020 -   4-   
PORTC=0x20; 
pulse_e();
delay_us(45);

send_cmd(0x28);

//  
// "      "
send_cmd(0x0f);

//  " "
send_cmd(0x01);
delay_ms(70); //   64 
             
//  "    "
//   1,   -  
//       3   
send_cmd(0x82);
delay_ms(70); //   64 

//  5 
for (i=0;i<5;i++)
     send_char(data[i]);	//    

while(1);		//  

} // main
