/* "   PIC "*/
#include <pic.h>

		/*   (PIC16F627/628)*/
__CONFIG (INTIO		//   RC  
	  	&DATUNPROT&UNPROTECT 	//     
	  	&BOREN 	//     
	  	&MCLRDIS	//    
   	  	&PWRTEN &WDTDIS	//   PWRT  WDT
 	 	 &LVPDIS);	//   

void interrupt InterFunc(void); /*    TMR0*/
void init(void); /*  */
void pause(unsigned int); /*,  */
void revers(unsigned int,unsigned char,unsigned char,unsigned char);/*,     */	

		unsigned int timer_power=0x0000;//  ""  (   7 )
		const unsigned int finish=255;// ,    ,       (   7 )
	
void main (void) 	/* */
{
	unsigned int time, i, j;	//    	
	init();		//  
/*    */
	PORTB=0xFF;	//   
	pause(9000); 	//  10 
	PORTB=0x00;	//   
	for(;;)		//   
	{	
	/*    */
	/*      ( )   ,     */
	/*    */
		revers(80,32,0b00000000,0b00000001);//   
		revers(80,32,0b10000000,0b00000000);//   
		revers(80,32,0b10000000,0b00000001);//    
		revers(80,32,0b11000000,0b00000011);//    ( )
		revers(80,42,0b10101010,0b00000000);//  
		revers(80,32,0b00000000,0b01010101);//  
		revers(80,42,0b10100000,0b00000101);
		revers(80,42,0b11111111,0b00000000);//  
		revers(80,22,0b00000000,0b00000000);//  
	/*     */	
		time=410;	
		for(i=0;i<10;i++)
		{
			revers(time,8,0b10000000,0b00000000);
			time=time-40;
		}
	/*     */	
		time=410;	
		for(i=0;i<10;i++)
		{
			revers(time,8,0b00000000,0b00000001);
			time=time-40;
		}
	/*      */	
		time=40;	
		for(i=0;i<10;i++)
		{
			revers(time,8,0b10001000,0b00000000);
			time=time+40;
		}
	/*      */	
		time=40;	
		for(i=0;i<10;i++)
		{
			revers(time,8,0b00000000,0b00010001);
			time=time+40;
		}
	/* ,        */	
		time=410;
		for(j=0;j<2;j++)
		{	
			for(i=0;i<10;i++)
			{
				revers(time,8,0b10000000,0b00000001);
				time=time-40;
			}				
			for(i=0;i<10;i++)
			{
				revers(time,8,0b10000000,0b00000001);
				time=time+40;
			}
		}
		revers(80,60,0b10101010,0b10101010); //  
		revers(80,60,0b11111111,0b00000000);//  
		revers(80,22,0b00000000,0b00000000);//  	
	}		
}

void interrupt InterFunc(void)	/*    TMR0*/
{ 
	T0IF=0;			//    TMR0
	timer_power++;		//     
	if(timer_power==finish)	//   , 	
	{
		INTCON=0x00;		//   
		PORTB=0x00;		// ""   ()
		asm("sleep");		//  ......
	}
}

void init(void)	/*  */
{
	OSCF=0;			//    RC   4   37 
	TRISB=0x00;		//      
	PORTB=0x00;		//      
	OPTION=0b11010111;	//   TMR0 (1:256)
	INTCON=0b10100000;	//       0
}

void pause(unsigned int time)	/*,  */
{				//t=time X 11  Tosc (Tosc=4/Fosc)
	while(time-->0);	//....
}

/*,     */
void revers(unsigned int time,//     
	      unsigned char END,//   
	      unsigned char port_A,//   
	      unsigned char port_B)//   
{
	unsigned char i,temp;
	for(i=0;i<END;i++)	//   
	{
		temp=port_A;		//  
		temp=temp|port_B;	//  ""  
		PORTB=temp;		//      
		pause(time);		//    
		port_A=port_A>>1;	//    
		if(CARRY) port_A=port_A|0x80;	//  CARRY ( )    
		port_B=port_B<<1;	//    
		if(CARRY) port_B=port_B|0x01;	//  CARRY ( )    
	}
}
