/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2006. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  PANEL                           1       /* callback function: QUIT_PANEL */
#define  PANEL_LED_ERROR                 2
#define  PANEL_LED_COM_PROGRESS          3
#define  PANEL_REG_5                     4
#define  PANEL_REG_4                     5
#define  PANEL_REG_3                     6
#define  PANEL_REG_2                     7
#define  PANEL_REG_1                     8
#define  PANEL_WRITE_REG                 9       /* callback function: DO_WRITE_REG */
#define  PANEL_READ_REG                  10      /* callback function: DO_READ_REG */
#define  PANEL_COMPORT                   11      /* callback function: DO_COMPORT_OPEN */
#define  PANEL_CYCLE_READ                12      /* callback function: D0_CYCLE_READ */
#define  PANEL_QUANT_REG                 13
#define  PANEL_ADDR_BLOCK                14
#define  PANEL_NUMBER_REG                15
#define  PANEL_DECORATION_4              16
#define  PANEL_TEXTMSG_7                 17
#define  PANEL_DECORATION_5              18
#define  PANEL_TEXTMSG_9                 19
#define  PANEL_TIMER_1                   20      /* callback function: DO_TICK_TIMER_1 */


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK D0_CYCLE_READ(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK DO_COMPORT_OPEN(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK DO_READ_REG(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK DO_TICK_TIMER_1(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK DO_WRITE_REG(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK QUIT_PANEL(int panel, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
